function httpObject (host)
{
	this.host = host;
}

httpObject.prototype = 
{
    getObject : function()
	{
        var xmlhttp;
        if (!xmlhttp && typeof XMLHttpRequest != 'undefined') {
	        try 
	        {
	           xmlhttp = new XMLHttpRequest();
	        }
	        catch (e) 
	        {
	           xmlhttp = false
	        }
	    }
	    return xmlhttp;
	},

	doRequest : function (verb, resLoc, getData, objData, isSync, arrMetadata, objAct, reqType)
    {
		try
		{
			var xmlhttp = this.getObject();
			if (getData != "")
				getData = "?" + getData;
			
			var aUrl = (resLoc.indexOf("http") == -1) ? this.host + resLoc + getData : resLoc + getData;
			xmlhttp.open (verb, aUrl, !isSync);
	        
	        if (verb == "POST")
			    xmlhttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			    
			if (arrMetadata instanceof Array)
			{
				for (var i = 0; i < arrMetadata.length; i++)
				{
					xmlhttp.setRequestHeader(arrMetadata[i].name, arrMetadata[i].value);
				}
			}		
			    
			resLoc = encodeURI(resLoc);
			xmlhttp.send(objData);		
			
			var domParser = new DOMParser();
			if (isSync)
			{
				if (xmlhttp.status >= 200 && xmlhttp.status < 300 )
				{
					var xmlDoc1 = domParser.parseFromString(xmlhttp.responseText, "text/xml");
					
					var responseObject = {xmlDoc: xmlDoc1, strHeaders: xmlhttp.getAllResponseHeaders(), requestType : reqType};
					//alert(xmlhttp.responseText);
					objAct.onResponseComplete(responseObject, xmlDoc1);						
					
					return responseObject;
				}
				else
				{
					var xmlDoc1 = domParser.parseFromString(xmlhttp.responseText, "text/xml");
					var errorMessage = "Error connecting! Try again - " + xmlhttp.status + " " + xmlhttp.statusText;
					if (xmlDoc1 != null && xmlDoc1.getElementsByTagName("Message")[0])
					    errorMessage = xmlDoc1.getElementsByTagName("Message")[0].firstChild.nodeValue;
					
					var responseObject = {xmlDoc: xmlDoc1, strHeaders: xmlhttp.getAllResponseHeaders(), requestType : reqType, eMesg : errorMessage, hasErrors : true};
					objAct.onResponseComplete(responseObject);			
										
					return false;
				}	
			}
			else
			{
				xmlhttp.onreadystatechange = function () {
					if (xmlhttp.readyState != 4)
						return;
					else
					{
						if (xmlhttp.status >= 200 && xmlhttp.status < 300 )
						{
							var xmlDoc1 = domParser.parseFromString(xmlhttp.responseText, "text/xml");
				
							var responseObject = {xmlDoc: xmlDoc1, strHeaders: xmlhttp.getAllResponseHeaders(), requestType : reqType};
							objAct.onResponseComplete(responseObject);						
						}
						else
						{
							var xmlDoc1 = domParser.parseFromString(xmlhttp.responseText, "text/xml");
							var errorMessage = "Error connecting! Try again - " + xmlhttp.status + " " + xmlhttp.statusText;
							if (xmlDoc1 != null && xmlDoc1.getElementsByTagName("Message")[0])
							    errorMessage = xmlDoc1.getElementsByTagName("Message")[0].firstChild.nodeValue;
							
							var responseObject = {xmlDoc: xmlDoc1, strHeaders: xmlhttp.getAllResponseHeaders(), requestType : reqType, eMesg : errorMessage, hasErrors : true};
							objAct.onResponseComplete(responseObject);			
						}
					}
				}
			}
		}
		catch (ex)
		{
			alert(ex);
		}
    },
    
    doRequestText : function (verb, resLoc, getData, objData, isSync, arrMetadata, objAct, reqType)
    {
		try
		{
			var xmlhttp = this.getObject();
			if (getData != "")
				getData = "?" + getData;
			
			var aUrl = (resLoc.indexOf("http") == -1) ? this.host + resLoc + getData : resLoc + getData;
			xmlhttp.open (verb, aUrl, !isSync);
	        
            if (verb == "POST")
			    xmlhttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
			
			if (arrMetadata instanceof Array)
			{
				for (var i = 0; i < arrMetadata.length; i++)
				{
					
					xmlhttp.setRequestHeader(arrMetadata[i].name, arrMetadata[i].value);
					
				}
			}
						
			resLoc = encodeURI(resLoc);
			xmlhttp.send(objData);		
			
			if (isSync)
			{
				if (xmlhttp.status >= 200 && xmlhttp.status < 300 )
				{
					var responseObject = {respText: xmlhttp.responseText, strHeaders: xmlhttp.getAllResponseHeaders(), requestType : reqType, isText: true};
					//alert(xmlhttp.responseText);
					objAct.onResponseComplete(responseObject);						
					return responseObject;
				}
				else
				{
					var responseObject = {respText: xmlhttp.responseText, strHeaders: xmlhttp.getAllResponseHeaders(), requestType : reqType, isText: true, eMesg : "Error getting response! - " + xmlhttp.status + " " + xmlhttp.statusText, hasErrors : true};
					objAct.onResponseComplete(responseObject);	
					return false;
				}	
			}
			else
			{
				xmlhttp.onreadystatechange = function () {
					if (xmlhttp.readyState != 4)
						return;
					else
					{
						if (xmlhttp.status >= 200 && xmlhttp.status < 300 )
						{
							var responseObject = {respText: xmlhttp.responseText, strHeaders: xmlhttp.getAllResponseHeaders(), requestType : reqType, isText: true};
							objAct.onResponseComplete(responseObject);						
						}
						else
						{
							var responseObject = {respText: xmlhttp.responseText, strHeaders: xmlhttp.getAllResponseHeaders(), requestType : reqType, isText: true, eMesg : "Error getting response!", hasErrors : true};
							objAct.onResponseComplete(responseObject);			
						}
						
					}
				}
			}
		}
		catch (ex)
		{
			alert(ex);
		}
    },
    
    downloadFile : function (cmnData, link, objAct, reqType, authHeader)
	{
		const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
		try
		{
			var file = helper.getTempFile();

			var uri = Components.classes['@mozilla.org/network/standard-url;1'].createInstance(Components.interfaces.nsIURI);
			uri.spec = link;
			var persistContractID = "@mozilla.org/embedding/browser/nsWebBrowserPersist;1";
			var persistIID = Components.interfaces.nsIWebBrowserPersist;
			var persist = Components.classes[persistContractID].createInstance(persistIID);
			persist.persistFlags = 	nsIWBP.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION | 
									nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | 
									nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
			persist.progressListener = new ProgressListener(objAct, reqType, cmnData, file);
			persist.saveURI(uri, null, null, null, authHeader, file);
			return 0;
		}
	    catch (ex)
	    {
			alert(ex);
	        return ex;
	    }
	}   
};

function ProgressListener(curAct, reqType, cmnData, file) 
{ 
	this.curAct = curAct;
	this.reqType = reqType;
	this.cmnData = cmnData;
	this.file = file;
}

ProgressListener.prototype = 
{
    QueryInterface: function(aIID)
	{
	    if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
		    aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		    aIID.equals(Components.interfaces.nsITransfer) ||
		    aIID.equals(Components.interfaces.nsISupports))
		    return this;
	    throw Components.results.NS_NOINTERFACE;
	},

	onStateChange: function(aProgress, aRequest, aFlag, aStatus)
	{
	    if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_START)
		{
			cmnData.status = "Download Progress: ";
		}
		else if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP)
		{
			try
			{
				
				if (aStatus != 0)
					throw "Download Failed! Connection lost.";
				else
				{	
					if (this.file.exists() && (this.cmnData.fileSize == -1 || this.file.fileSize == this.cmnData.fileSize))
					{
						cmnData.progress = 100;
						var reqType = this.reqType;
						cmnData.status = "Complete";
						cmnData.file = this.file;
						cmnData.setStatus(cmnData.status,"status");
						var is = Components.classes["@mozilla.org/network/file-input-stream;1"]
								.createInstance( Components.interfaces.nsIFileInputStream );
						is.init( cmnData.file,0x01, 00004, null);
						var sis = Components.classes["@mozilla.org/scriptableinputstream;1"]
								.createInstance( Components.interfaces.nsIScriptableInputStream );
						sis.init( is );
						var output = sis.read( sis.available() );
						cmnData.source = output;
						if (this.file.exists())
							this.file.remove(true);
					}
					else
					{
						if (this.file.exists())
							this.file.remove(true);
						throw "Download Failed! Invalid Url.";
					}
				}
			}
			catch (ex)
			{
				helper.cmnData.progress = 0;
				var reqType = this.reqType;
				helper.cmnData.status = "Failed";
				helper.setStatus(helper.cmnData.status);
			}
		}
		return 0;
	},

	onLocationChange: function(aProgress, aRequest, aURI)
	{
	    return 0;
	},

	onProgressChange: function(aProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress)
	{
		if (aMaxSelfProgress == -1)
			aMaxSelfProgress = aCurSelfProgress;
		cmnData.progress = Math.round(aCurSelfProgress / aMaxSelfProgress * 100);
		var status = cmnData.status + cmnData.progress + "%";
		cmnData.setStatus(status,"status");
		return 0;
	},
	onStatusChange: function() {return 0;},
	onSecurityChange: function() {return 0;},
	onLinkIconAvailable: function() {return 0;}
}

