var gXBEL=null;

function StartUp()
{
	gXBEL=new BookmarksSynchronizerXBEL();
	doSortBookmarksFolderWithOptions("NC:BookmarksRoot", gXBEL.settings.getBool("casesensitive",true), gXBEL.settings.getBool("folderfirst",true), gXBEL.settings.getBool("recursive",true), gXBEL.settings.getBool("separatorgroup",false), gXBEL.settings.getBool("excludetoolbar",true), "Name");
}

function cancelSort()
{
	setTimeout(close,0);
}

function doSortBookmarksFolderWithOptions( resourceID , caseSensitive , folderFirst , recursive , separatorGroup, exculdeToolbar , sortBy)
{
	var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
				.getService(Components.interfaces.nsIRDFService);
	var Container = Components.classes["@mozilla.org/rdf/container;1"]
				.getService(Components.interfaces.nsIRDFContainer);
	var RDFCUtils = Components.classes['@mozilla.org/rdf/container-utils;1']
				.getService(Components.interfaces.nsIRDFContainerUtils);

	var DataSource=RDFService.GetDataSource("rdf:bookmarks");
	DataSource.QueryInterface(Components.interfaces.nsIBookmarksService);

	var root=RDFService.GetResource(resourceID);
	if(!RDFCUtils.IsContainer(DataSource,root)) return;

	if(!sortBy) sortBy=Name;

    var rdfType;
	var isReverse=false;
	switch(sortBy)
	{
		case "Name":
		case "Icon":
		case "URL":
		case "Description":
			rdfType=Components.interfaces.nsIRDFLiteral;
			break;
		case "LastVisitDate":
		case "LastModifiedDate":
			rdfType=Components.interfaces.nsIRDFDate;
			isReverse=true;
			break;
		default:
			rdfType=Components.interfaces.nsIRDFLiteral;
			break;
	};

	var arc;
	switch(sortBy)
	{
		case "Name":
		case "Icon":
		case "URL":
		case "Description":
			arc=RDFService.GetResource("http://home.netscape.com/NC-rdf#"+sortBy);
			break;
		case "LastVisitDate":
		case "LastModifiedDate":
			arc=RDFService.GetResource("http://home.netscape.com/WEB-rdf#"+sortBy);
			break;
		default:
			arc=RDFService.GetResource("http://home.netscape.com/NC-rdf#"+sortBy);
			break;
	};

	var typeArc=RDFService.GetResource("http://www.w3.org/1999/02/22-rdf-syntax-ns#type");
	var sepVal=RDFService.GetResource("http://home.netscape.com/NC-rdf#BookmarkSeparator");

	var TBFURI=null;
	if(exculdeToolbar)
	{
		var tbfArc=RDFService.GetResource("http://home.netscape.com/NC-rdf#BookmarksToolbarFolder");
		var trueVal=RDFService.GetLiteral("true");
		var TBF=DataSource.GetSource(tbfArc,trueVal,true);
		if(TBF) TBFURI=TBF.QueryInterface(Components.interfaces.nsIRDFResource).Value;
		if(resourceID==TBFURI) return;
	}

	var sortfolders=[root];

	DataSource.beginUpdateBatch();

	while(sortfolders.length>0)
	{
		var sortfolder=sortfolders.shift();
		Container.Init(DataSource,sortfolder);
		var elements=Container.GetElements();
		var folders=[];
		var bookmarks=[];
		var sortedarray=[];
		while(elements.hasMoreElements())
		{
			var temp={uri:"",name:"",toString:function(){return this.name;}};
			var element=elements.getNext();
			element.QueryInterface(Components.interfaces.nsIRDFResource);
			temp.uri=element.Value;

			try{
				var target=DataSource.GetTarget(element,arc,true);
				if(target)
					temp.name= target.QueryInterface(rdfType).Value.toString();
				if(!caseSensitive) temp.name=temp.name.toUpperCase();
			}catch(e){}

			Container.RemoveElement(element,false);
			if( separatorGroup && DataSource.HasAssertion ( element , typeArc , sepVal , true))
			{
				folders.sort();
				bookmarks.sort();
				sortedarray=sortedarray.concat(folders);
				sortedarray=sortedarray.concat(bookmarks);
				sortedarray.push(temp);//this sep
				folders=[];
				bookmarks=[];
			}
			else if(RDFCUtils.IsContainer(DataSource,element))
			{
				if(recursive && TBFURI != element.Value)
					sortfolders.push(element);
				if(folderFirst) folders.push(temp);
				else bookmarks.push(temp);
			}
			else bookmarks.push(temp);
		}

		folders.sort();
		bookmarks.sort();
		if(isReverse) bookmarks.reverse();
		sortedarray=sortedarray.concat(folders);
		sortedarray=sortedarray.concat(bookmarks);

		for(var i in sortedarray)
			Container.AppendElement(RDFService.GetResource(sortedarray[i].uri));
	}

	DataSource.endUpdateBatch();
	setTimeout('DataSource.transactionManager.clear()', 0);
	cancelSort();
}